#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <float.h>

#include "Image.h"

Image::Image(int _width, int _height) 
: width(_width)
, height(_height) 
, img_size(width * height)
{
   data_size = img_size * 3;
   data = new unsigned char[data_size];
}

Image::~Image() {
   delete [] data;
}

Image* Image::ReadBitmap(const char* file) {
   Image* img;
   FILE* in = NULL;
   unsigned int offset;
   unsigned int swap;
   int width, height;
   
   in = fopen(file, "r");
   if (in == NULL) {
      perror("fopen");
      exit(1);
   }

   fseek(in, 10, SEEK_SET); // Find data beginning
   fread(&offset, 4, 1, in);

   fseek(in, 18, SEEK_SET); // Go to the sizes
   fread(&width, 4, 1, in);
   fread(&height, 4, 1, in);

   img = new Image(width, height);

   fseek(in, offset, SEEK_SET); // Go to the data segment
   fread(img->data, sizeof(unsigned char), img->img_size * 3, in);

   for (int i = 0; i < img->img_size; i++) {
      // Swap to deal with BGR byte ordering of bitmap --
      //  Bitmap was probably designed in the same vein as Little Endian...
      swap = img->data[3 * i];
      img->data[3 * i] = img->data[3 * i + 2];
      img->data[3 * i + 2] = swap;
   }
   return img;
}
