#ifndef GL_UTIL_H
#define GL_UTIL_H

#ifndef GL_GLEXT_PROTOTYPES
#define GL_GLEXT_PROTOTYPES
#endif

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

void init_gl();
void glut_resize(int w, int h);
void center_cursor();

// Taken from ZJW's 473 Lab 5 sample code
int printOglError (const char *file, int line);
void printProgramInfoLog (unsigned int program);
void printShaderInfoLog (unsigned int shader);
#define printOpenGLError() printOglError(__FILE__, __LINE__)
GLint getUniLoc(GLuint program, const GLchar *name);
GLint getAttribLoc(GLuint program, const GLchar *name);

void draw_base_grid();

int compile_vertex_shader(const char* path);
int compile_fragment_shader(const char* path);
int compile_program(int vshader, int fshader);
void activate_program(int prog);
void deactivate_shaders();

#endif
