#ifndef GLOBALS_H
#define GLOBALS_H

#include <map>

struct Plane;

namespace globals {
   extern std::map<unsigned char, bool> keys;
   extern std::map<int, bool> special_keys;

   extern bool warp_mouse;
   extern int elapsed_time;

   namespace main_win {
      extern int width;
      extern int height;
      extern int pos_x;
      extern int pos_y;

      extern int handle;
   }

   namespace cam {
      extern float pos_x;
      extern float pos_y;
      extern float pos_z;

      extern float ang_x;
      extern float ang_y;
      extern float ang_z;

      extern float near_plane_dist;
      extern float far_plane_dist;
      extern float field_of_view;
   }

   namespace light {
      extern float pos[4];
   }

   namespace shaders {
      extern int vshader;
      extern int fshader;
      extern int prog;

      extern unsigned int bump_tex_handle;
      extern unsigned int decal_tex_handle;
   }
}

#endif
