#ifndef UTIL_H
#define UTIL_H
#include <math.h>

inline float dot(const float* a, const float* b) {
   return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}

inline void cross(const float* a, const float* b, float* dest) {
   dest[0] = a[1] * b[2] - a[2] * b[1];
   dest[1] = a[2] * b[0] - a[0] * b[2];
   dest[2] = a[0] * b[1] - a[1] * b[0];
}

inline void normalize(float* a) {
   float len = sqrt(a[0] * a[0] + a[1] * a[1] + a[2] * a[2]);
   a[0] /= len;
   a[1] /= len;
   a[2] /= len;
}

inline void triangle_normal(float *a, float* b, float* c, float* dest) {
   float e1[3];
   float e2[3];

   e1[0] = b[0] - a[0];
   e1[1] = b[1] - a[1];
   e1[2] = b[2] - a[2];
   normalize(e1);

   e2[0] = c[0] - a[0];
   e2[1] = c[1] - a[1];
   e2[2] = c[2] - a[2];
   normalize(e2);

   cross(e1, e2, dest);
   normalize(dest);
}

char* slurp_file(const char* path);

#endif
