
varying vec3 view;
varying vec3 light;

attribute vec3 binormal;
attribute vec3 tangent;

void main() {
   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
   gl_TexCoord[0].st = gl_MultiTexCoord0.st;

   mat4 inv_mv = gl_ModelViewMatrixInverse;

   vec4 pos_es = gl_ModelViewMatrix * gl_Vertex;

   vec4 light_es = gl_LightSource[0].position - pos_es;
   vec4 light_os = inv_mv * light_es;

   vec4 view_es = -1.0 * vec4(pos_es.xyz, 0.0);
   vec4 view_os = inv_mv * view_es;

   vec3 T = normalize(tangent);
   vec3 B = normalize(binormal);
   vec3 N = normalize(gl_Normal);

   mat3 TBN = mat3(T, B, N);
   mat3 tran_TBN = transpose(TBN);

   light = normalize(tran_TBN * light_os.xyz);
   view = normalize(tran_TBN * view_os.xyz);
}
